<?

/*
	Show sudoku's from database

        (C) Copyright 2005 by Mogens Kjaer, mk@lemo.dk

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License 
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

include('utilities.php');

sudoku_db();

echo "<HTML>\n";
echo "<HEAD>\n";
echo "  <META HTTP-EQUIV=\"content-type\" CONTENT=\"TEXT/HTML; CHARSET=ISO-8859-1\">\n";
echo "  <TITLE>Sudoku opgaver</TITLE>\n";
echo "  <link rel=\"stylesheet\" type=\"text/css\" href=\"sudoku.css\" title=\"Default\">\n";
echo "</HEAD>\n";
echo "<body>\n";

if(isset($nx)&&isset($ny)&&isset($ndigits)&&isset($level)&&isset($symmetrical)&&!isset($serial))
{
  $res1 = mysql_query("select serial from sudoku where nx=".$nx." and ny=".$ny.
                      " and ndigits=".$ndigits." and level=".$level." and ".
		      "symmetrical=".$symmetrical." order by lastused limit 1");
  if($row1 = mysql_fetch_assoc($res1))
  {
    $serial = $row1["serial"];
  }
}

if(isset($serial))
{
  $res1=mysql_query("select * from sudoku where serial=".$serial);
  if($row1 = mysql_fetch_assoc($res1))
  {
    echo "<h1>Opgave nr. ".$row1["serial"]."</h1>\n";
    $nx = $row1["nx"];
    $ny = $row1["ny"];
    $res2 = mysql_query("update sudoku set lastused=now() where serial=".$serial);
    $nxny = $nx*$ny;
    if(isset($solution))
    {
      $txt = $row1["solution"];
    }
    else
    {
      $txt = $row1["problem"];
    }
    echo "<p align=center>";
    echo "<table class=\"s\">\n";
    $index=0;
    for($i=0;$i<$nxny;$i++)
    {
      echo "<tr class=\"s\">";
      for($j=0;$j<$nxny;$j++)
      {
	$c = substr($txt,$index,1);
        echo "<td class=\"s";
	if(($i%$nx)==0 && $i>0) echo " thicktop";
	if((($j+1)%$ny)==0 && $j<($nxny-1)) echo " thickright";
	if($c!="0" && substr($row1["problem"],$index,1)=="0") echo " solution";
	echo "\">";
	if($c=="0")
	{
	  echo "&nbsp;";
	}
	else
	{
	  echo $c;
	}
	echo "</td>\n";
	$index++;
      }
      echo "</tr>\n";
    }
    echo "</table></p>\n";
    echo "<p></p>\n";
    echo "<p class=\"s\">Opgavetype: ".level_text($row1["level"]);
    echo "<br>\n";
    echo "Symmetri: ".symmetrical_text($row1["symmetrical"]);
    if(isset($solution))
    {
      echo "<br><a href=\"sudoku.php?serial=".$serial."\">Vis opgave</a>";
    }
    else
    {
      echo "<br><a href=\"sudoku.php?serial=".$serial."&solution\">Vis lsning</a>";
      $res2 = mysql_query("select count(serial) as number from sudoku ".
                          "where nx=".$row1["nx"].
			  " and ny=".$row1["ny"].
			  " and ndigits=".$row1["ndigits"].
			  " and level=".$row1["level"].
			  " and symmetrical=".$row1["symmetrical"]);
      if($row2 = mysql_fetch_assoc($res2))
      {
        if($row2["number"]>1)
	{
	  echo "<br><a href=\"sudoku.php?nx=".$row1["nx"].
				       "&ny=".$row1["ny"].
				       "&ndigits=".$row1["ndigits"].
				       "&level=".$row1["level"].
				       "&symmetrical=".$row1["symmetrical"]."\">Vis anden opgave af samme type</a> af ".
				       $row2["number"]." mulige\n";
	}
      }
      echo "<br><a href=\"sudoku.php\">Alle opgavetyper</a>";
    }
    echo "</p>\n";
  }
  else
  {
    echo "<h1>Fejl!</h1>\n";
    echo "<p>Opgave ".$serial." findes ikke.</p>\n";
  }
}
else if(isset($nx)&&isset($ny)&&isset($symmetrical)&&isset($level))
{
  echo "<h1>".$nx."x".$ny." opgaver, symmetri: ".symmetrical_text($symmetrical).", svrhedsgrad: ".level_text($level)."</h1>\n";
  echo "<table border=1>\n";
  echo "<th>Antal fyldte celler<th>Antal\n";
  $res1 = mysql_query("select ndigits,count(serial) as number from sudoku where nx=".$nx." and ny=".$ny.
                      " and symmetrical=".$symmetrical." and level=".$level." group by ndigits");
  while($row1 = mysql_fetch_assoc($res1))
  {
    echo "<tr>";
    echo "<td align=center><a href=\"sudoku.php?nx=".$nx."&ny=".$ny."&symmetrical=".$symmetrical."&level=".$level."&ndigits=".$row1["ndigits"]."\">";
    echo $row1["ndigits"];
    echo "</a>";
    echo "<td align=right>".$row1["number"];
  }
  echo "</table>\n";
}
else if(isset($nx)&&isset($ny)&&isset($symmetrical))
{
  echo "<h1>".$nx."x".$ny." opgaver, symmetri: ".symmetrical_text($symmetrical)."</h1>\n";
  echo "<table border=1>\n";
  echo "<th>Svrhedsgrad<th>Antal\n";
  $res1 = mysql_query("select level,count(serial) as number from sudoku where nx=".$nx." and ny=".$ny.
                      " and symmetrical=".$symmetrical." group by level");
  while($row1 = mysql_fetch_assoc($res1))
  {
    echo "<tr>";
    echo "<td align=center><a href=\"sudoku.php?nx=".$nx."&ny=".$ny."&symmetrical=".$symmetrical."&level=".$row1["level"]."\">";
    echo level_text($row1["level"]);
    echo "</a>";
    echo "<td align=right>".$row1["number"];
  }
  echo "</table>\n";
}
else
{
  echo "<h1>Opgavetyper</h1>\n";
  echo "<table border=1>\n";
  echo "<tr><th rowspan=2>Strrelse<th colspan=3>Antal opgaver:<br>Symmetri\n";
  echo "<tr><td>Ingen<td>Spejling i x og y<td>180<sup>o</sup> rotation\n";
  $res1 = mysql_query("select nx,ny,symmetrical,count(serial) as number from sudoku group by nx,ny,symmetrical");
  $lastnx=999;
  $lastny=999;
  $lastsymmetrical=999;
  while($row1 = mysql_fetch_assoc($res1))
  {
    if($lastnx != $row1["nx"] ||
       $lastny != $row1["ny"])
    {
      echo "<tr>";
      echo "<td align=center>".$row1["nx"]."x".$row1["ny"];
      $lastsymmetrical=-1;
    }
    for($i=0;$i<($row1["symmetrical"]-$lastsymmetrical-1);$i++)
    {
      echo "<td>&nbsp;";
    }
    echo "<td align=right><a href=\"sudoku.php?nx=".$row1["nx"]."&ny=".$row1["ny"]."&symmetrical=".$row1["symmetrical"]."\">".$row1["number"]."</a>\n";
    $lastnx = $row1["nx"];
    $lastny = $row1["ny"];
    $lastsymmetrical = $row1["symmetrical"];
  }
  echo "</table>\n";
  echo "<p></p>\n";
  echo "<p>Klik p tallet ud for den sudoku strrelse, du er interesseret i. Opgaverne\n";
  echo "er opdelt efter symmetrien i felterne.</p>\n";
  echo "<p>Klik <a href=\"pdf.php\">hr</a> for at hente mange opgaver med lsninger. Opgaverne hentes i en PDF fil - lige til at skrive ud.</p>\n";
  echo "<p><form method=post action=\"$PHP_SELF\">G direkte til opgave nr. <input name=serial size=7><input type=submit value=\"Vis\"></form></p>\n";
  echo "<p><b>Bemrk:</b> Databasen og webserveren krer p en gammel 450 MHz Pentium II maskine, s opslagene tager nogle gange lidt tid...</p>\n";
}

echo "</body>\n";
echo "</html>\n";
?>
